#!/usr/bin/env python2
# -*- coding: utf-8 -*-

from src.inAndOut.Leitura import Leitura
from src.inAndOut.Escrita import Escrita
from src.exceptions.ErroFormatacaoException import ErroFormatacaoException
from src.exceptions.FileNotFoundException import FileNotFoundException
from src.exceptions.InconsistenciaException import InconsistenciaException

import sys, traceback

if __name__ == "__main__":
    listaQualis = ["A1", "A2", "B1", "B2", "B3", "B4", "B5", "C"]
    nomePlanilhaDocentes = ""
    nomePlanilhaVeiculos = ""
    nomePlanilhaPublicacoes = ""
    nomePlanilhaQualificacoes = ""
    nomePlanilhaRegras = ""
    anoString = ""
    
    i = 1
    while i < len(sys.argv):
        if sys.argv[i] == "-d":
            i=i+1
            nomePlanilhaDocentes = sys.argv[i]
        if sys.argv[i] == "-a":
            i=i+1
            anoString = sys.argv[i]
        if sys.argv[i] == "-v":
            i=i+1
            nomePlanilhaVeiculos = sys.argv[i]    
        if sys.argv[i] == "-r":
            i=i+1
            nomePlanilhaRegras = sys.argv[i]        
        if sys.argv[i] == "-q":
            i=i+1
            nomePlanilhaQualificacoes = sys.argv[i]
        if sys.argv[i] == "-p":
            i=i+1
            nomePlanilhaPublicacoes = sys.argv[i]
        i=i+1
                        
    leitura = Leitura(listaQualis,nomePlanilhaDocentes,nomePlanilhaVeiculos,\
                      nomePlanilhaPublicacoes,nomePlanilhaQualificacoes,nomePlanilhaRegras)
    escrita = Escrita(listaQualis,"1-recredenciamento.csv","2-publicacoes.csv","3-estatisticas.csv")                      
    
    dadosEntrada = None
    try:
        dadosEntrada = leitura.leArquivos()
        dadosEntrada.parseAno(anoString)
        escrita.escreveRelatorios(dadosEntrada)
    except FileNotFoundException:
        traceback.print_exc(file=sys.stdout)
        print "Erro de I/O"
    except InconsistenciaException as e:
        print str(e)
    except ErroFormatacaoException:
        print "Erro de formatação"
    
