#!/usr/bin/env python2
# -*- coding: utf-8 -*-

class Regra():
    #Esta classe representa uma Regra cadastrada no sistema,
    #armazenando seus respectivos dados.

    #Ela possui atributos como data de inicio e fim, um mapa de qualificações,
    #onde a chave é uma string e o valor é um inteiro (a pontuação do qualis com o nome igual a String)
    #o multiplicador para publicações em periódicos
    #o número de anos para considerar no cálculo da pontuação
    #a pontuação mínima para um docente se credenciar.
    def __init__(self, inicioVigencia = None, fimVigencia = None, multiplicadorPeriodico = None,\
                 anosparaConsiderar = None, pontuacaoMinima = None):
        self.inicioVigencia = inicioVigencia
        self.fimVigencia = fimVigencia
        self.multiplicadorPeriodico = multiplicadorPeriodico
        self.anosparaConsiderar = anosparaConsiderar
        self.pontuacaoMinima = pontuacaoMinima
        self.mapaPontuacoes = {} #Cria um dicionário vazio (equivalente a um mapa)


    #Função para adicionar uma pontuação para uma qualificação específica
    def adicionaPontuacao(self, qualis, pontuacao):
        # Adiciona pontuação a um qualis (somente se ele não existir)
        if qualis not in self.mapaPontuacoes:
            self.mapaPontuacoes[qualis] = pontuacao

    #Função para retornar a pontuação de um determinado qualis
    def getPontuacaoQualis(self, qualis):
        #Retorna pontuação de um dado qualis. Caso ele não esteja cadastrado, retorna 0;
        if qualis in self.mapaPontuacoes:
            return self.mapaPontuacoes[qualis]
        return 0
