#!/usr/bin/env python2
# -*- coding: utf-8 -*-

import Qualificacao
import Publicacao
#import ../exceptions/InconsistenciaException

class Veiculo():
    #Esta classe representa um Veiculo cadastrado no sistema,
    #armazenando seus respectivos dados.

    #Um veiculo possui atributos como Sigla, Nome, Tipo, fatorImpacto, ISSN, um
    #mapa de qualificações, onde a chave é um ano e o valor é uma qualificação
    #(um qualis), e a lista de publicações neste veiculo.
    def __init__(self, sigla = None, nome = None, tipo = None, fatorImpacto = None, issn = None):
        self.sigla = sigla
        self.nome = nome
        self.tipo = tipo
        self.fatorImpacto = fatorImpacto
        self.issn = issn
        self.mapaQualificacoes = {} #Dicionario vazio
        self.listaPublicacoes = [] #Lista vazia


    #Função para adicionar uma qualificação no mapa de qualificações;
    def adicionaQualificacao(self, qualificacao):
        #Adiciona uma qualificação para um veículo (somente se uma qualificação para
        #o ano especificado já não existir.
        #Caso ela já exista, a qualificacao é apagada (a que fica armazenada é a
        #primeira inserida.
        if qualificacao.ano not in self.mapaQualificacoes:
            self.mapaQualificacoes[qualificacao.ano] = qualificacao

    #função para retornar uma publicação a lista de publicações de um veiculos
    def adicionaPublicacao(self, publicacao):
        self.listaPublicacoes.append(publicacao)


    #Função para retornar a qualificação vigente dado um ano
    #A função percorre as chaves do mapa de qualificações, encontrando a mais próxima;
    #Como o mapa é ordenado, o programa sobrescreve r até encontrar a ultima
    #qualificação anterior ao ano especificado, a retornando.
    def getQualificacaoAno(self, ano):
        #Caso a qualificação não exista, ela deve ser considerada "NC"
        r = "NC";
        #Percorre o mapa de qualificações com a finalidade de encontrar a qualificação
        #mais recente (e anterior ao ano especificado).
        #A qualificação encontrada é retornada. Caso não seja encontrada, uma exceção
        #é lançada
        for key in sorted(self.mapaQualificacoes):
            if key <= ano:
                r = self.mapaQualificacoes[key].qualis
        return r
